#ifndef FLAGSET_HPP_INCLUDED
#define FLAGSET_HPP_INCLUDED


#include"util.hpp"


struct
FlagSet
{
  using Element = std::pair<std::string,uint>;

  const std::vector<Element>  elements;

  FlagSet(std::initializer_list<Element>  ls);

  uint                operator[](const std::string&  s) const;
  const std::string&  operator[](uint  flag) const;

};


#endif




