#ifndef SPACE_HPP_INCLUDED
#define SPACE_HPP_INCLUDED


#include"util.hpp"


enum
class Dir
{
    left,
   right,
   front,
    back,
     top,
  bottom,

  END,
};


class SuperSpace;
class      Block;


class
Space
{
  Block*  block;

  Space*  links[(int)Dir::END];

public:
  SuperSpace&  superspace;

  const Coord  coord;

  Space(SuperSpace&  spsp, int  x, int  y, int  z);

  void  wake_upper();

  Space*  get_link(Dir  dir            );
  void    set_link(Dir  dir, Space*  sp);

        Block*  get_block()      ;
  const Block*  get_block() const;

  void    set_block(Block*  blk);

  bool  start_move_block(Dir  dir_id, int  pushing_power=0);

  void  construct_block(bool  bubbly=false);
  void   destruct_block(                  );

};




#endif




