#ifndef CHIPMAP_HPP_INCLUDED
#define CHIPMAP_HPP_INCLUDED


#include"util.hpp"
#include"block.hpp"


class
ChipMap
{
  std::vector<uint32_t>  chips;

  int  chip_number;

  const int  chip_w;
  const int  chip_h;

  const int  table_w;
  const int  table_h;

  std::vector<uint32_t>  table;

public:
  ChipMap(int  _chip_w, int  _chip_h, int  _table_w, int  _table_h);

  int  push_back(const uint32_t*  colors);

        uint32_t*  get_chip(int  i)      ;
  const uint32_t*  get_chip(int  i) const;

  int   get_index(        int  x, int  y) const;
  void  set_index(int  i, int  x, int  y)      ;

};




#endif




