#include"flagset.hpp"




FlagSet::
FlagSet(std::initializer_list<Element>  ls): elements(ls)
{
}




uint
FlagSet::
operator[](const std::string&  s) const
{
    for(auto&  el: elements)
    {
        if(el.first == s)
        {
          return el.second;
        }
    }


  return 0;
}


const std::string&
FlagSet::
operator[](uint  flag) const
{
  static const std::string  nulls;

    for(auto&  el: elements)
    {
        if(el.second == flag)
        {
          return el.first;
        }
    }


  return nulls;
}




