#include"block.hpp"
#include"space.hpp"
#include"superspace.hpp"




const Rect3D&
SuperSpace::
get_view_rect() const
{
  return view_rect;
}


Rect3D&
SuperSpace::
get_view_rect()
{
  return view_rect;
}




void
SuperSpace::
move_view_left(int  dist)
{
  view_rect.x -= dist;

    if(view_rect.x < 0)
    {
      view_rect.x = 0;
    }
}


void
SuperSpace::
move_view_right(int  dist)
{
  view_rect.x += dist;

    if((view_rect.x+view_rect.x_width) > x_width)
    {
      view_rect.x = (x_width-view_rect.x_width);
    }
}


void
SuperSpace::
move_view_back(int  dist)
{
  view_rect.y -= dist;

    if(view_rect.y < 0)
    {
      view_rect.y = 0;
    }
}


void
SuperSpace::
move_view_front(int  dist)
{
  view_rect.y += dist;

    if((view_rect.y+view_rect.y_width) > y_width)
    {
      view_rect.y = (y_width-view_rect.y_width);
    }
}


void
SuperSpace::
move_view_top(int  dist)
{
  view_rect.z += dist;

    if((view_rect.z+view_rect.height) > height)
    {
      view_rect.z = (height-view_rect.height);
    }
}


void
SuperSpace::
move_view_bottom(int  dist)
{
  view_rect.z -= dist;

    if(view_rect.z < 0)
    {
      view_rect.z = 0;
    }
}




